#include <stdio.h>
#include <sys/time.h>
#include "../common.h"
#include <valarray>
#include <vector>
#include <unistd.h>

static void operation(int &x){
    OPERATION(x);
}

using namespace std;

#define UPDATE_TIME(total) do{ end_t=clock(); total = (end_t - start_t)*1000 / CLOCKS_PER_SEC; start_t=end_t;}while(0)

int main(){
    clock_t init_t, start_t, end_t;
    int i, k;
    
    volatile int result[SIZE]; //volatile is used to be sure that the compiler  execute the calcul.
    int tab[SIZE]={0};
    valarray<int> array(SIZE);
    vector<int> vect(SIZE);
    
    int total1, total2, total3, total4,  total5=0, total6=0, total7=0, total_t;
    
    init_t=start_t=clock();
    for (k=0; k<TRIALS_NB; k++ ){
        for (i=0; i<SIZE; i++){
            OPERATION(tab[i]);
        }
    }
    for (int i=0; i<SIZE; i++) result[i]=tab[i];
    UPDATE_TIME(total1);
    
    for (k=0; k<TRIALS_NB; k++ ){
        for (i=0;i!=SIZE; i++){
            OPERATION(tab[i]);
        }
    }
    for (int i=0; i<SIZE; i++) result[i]=tab[i];
    UPDATE_TIME(total2);

    for (k=0; k<TRIALS_NB; k++ ){
        for (i=SIZE-1; i--;){
            OPERATION(tab[i]);
        }
    }
    for (int i=0; i!=SIZE; i++) result[i]=tab[i];
    UPDATE_TIME(total3);
    
    for (k=0; k<TRIALS_NB; k++ ){
        OPERATION(array);
    }
    for (int i=0; i<SIZE; i++) result[i]=array[i];
    UPDATE_TIME(total4);
    
    for (k=0; k<TRIALS_NB; k++ ){
        for_each(vect.begin(), vect.end(), operation );
    }
    for (int i=0; i<SIZE; i++) result[i]=vect[i];
    UPDATE_TIME(total5);
    
    for (k=0; k<TRIALS_NB; k++ ){
        for_each(vect.begin(), vect.end(), [](int &x){ OPERATION(x);}); //does not work avec xcode ???
    }
    for (int i=0; i<SIZE; i++) result[i]=vect[i];
    UPDATE_TIME(total6);
    
    for (k=0; k<TRIALS_NB; k++ ){
        for (int &x : vect)  OPERATION(x);
    }
    for (int i=0; i<SIZE; i++) result[i]=vect[i];
    UPDATE_TIME(total7);
    
    total_t = (end_t-init_t)*1000/CLOCKS_PER_SEC;
    fprintf(stderr, "Finish c-style: %dms %dms %dms valarray: %dms  vector:  %dms %dms  %dms total:%dms\n", total1, total2, total3, total4, total5, total6, total7, total_t);
    
    return 0;
}
